function [gdat_data,error_status] = get_signal_d3d(signal,gdat_data);

gdat_data.data = mdsvalue(signal);
error_status = 1;

gdat_data.dim = [];
gdat_data.dimunits = [];
gdat_data.t = [];
gdat_data.x = [];
nbdims=numel(setdiff(size(gdat_data.data),1));
if ~isempty(gdat_data.data) && ~ischar(gdat_data.data)
  gdat_data.units = mdsvalue(['units_of(' signal ')']);
  if prod(size(gdat_data.data)) > 1
    for i=1:nbdims
      gdat_data.dim{i} = mdsvalue(['dim_of(' signal ',' num2str(i-1) ')']);
      % gdat_data.dimunits{i} = mdsvalue(['dimunits_of(' signal ',' num2str(i-1) ')']);
      gdat_data.dimunits{i} = 'to get';
    end
    if nbdims==1
      gdat_data.t = gdat_data.dim{1};
      gdat_data.x = [];
    else
      gdat_data.t = gdat_data.dim{1};
      gdat_data.x = gdat_data.dim{2};
    end
    error_status = 0;
  end
end

